<template>
  <div>
    <Navbar />
    <ValidationObserver
      v-slot="{ valid }"
      ref="observer"
      tag="form"
      @submit.prevent="submit()"
    >
      <b-container>
        <b-row>
          <b-col>
            <div class="addQuery-wrapper">
              <b-row>
                <b-col xl="4">
                  <div class="addQuery-sidebar">
                    <h1>Paciente</h1>

                    <hr>

                    <ValidationProvider
                      v-slot="{ errors, valid, touched }"
                      :rules="'required'"
                      :state="valid"
                      name="select"
                    >
                      <b-form-select
                        v-model="selected"
                        :options="options"
                        :state="touched ? valid : null"
                      >
                      </b-form-select>

                      <span class="error">
                        {{ errors[0] }}
                      </span>
                    </ValidationProvider>  

                    <div class="addQuery-sidebar--pacient" v-if="getPacient">
                      <div class="img-content">
                        <img :src="getPacient[0].img" alt="">
                      </div>
                      <h3>{{ getPacient[0].text }}</h3>

                      <p>{{ getPacient[0].description }}</p>
                    </div>
                  </div>
                </b-col>

                <b-col xl="8">
                  <div class="addQuery-form">
                    <h1>Consulta</h1>

                    <hr>

                    <div class="addQuery-form--sendbox">
                      <b-row>
                        <b-col xl="6">
                          <b-calendar
                            v-model="value"
                            @context="onContext"
                            v-bind="labels['ptBr'] || {}"
                            :locale="locale">
                          </b-calendar>
                        </b-col>

                        <b-col xl="6">
                          <label>Observação:</label>
                           <ValidationProvider
                              v-slot="{ errors, valid, touched }"
                              :rules="'required'"
                              :state="valid"
                              name="select"
                            >
                              <b-form-textarea
                                id="textarea"
                                v-model="msg"
                                :state="touched ? valid : null"
                                placeholder="Escreva a observação"
                                rows="3"
                                max-rows="6"
                              />

                              <span class="error">
                                {{ errors[0] }}
                              </span>
                           </ValidationProvider>  
                        </b-col>
                      </b-row>
                    </div>
                  </div>
                </b-col>
              </b-row>

              <b-row >
                <b-col md="12" class="d-flex justify-content-md-end">
                  <b-button
                    variant="primary uppercase"
                    @click="submit"
                    :disabled="!valid || !value"
                    v-b-modal.modalQueryConfirm>
                      Agendar Consulta
                  </b-button>
                </b-col>
              </b-row>
            </div>
          </b-col>
        </b-row>

        <feedback-request />

        <modal-query-confirmation :query="queryParam" />
      </b-container>
    </ValidationObserver>
  </div>
</template>

<script>
import Navbar from '@/components/Navbar'
import FeedbackRequest from '@/components/FeedbackRequest'
import ModalQueryConfirmation from '@/components/ModalQueryConfirm'
import { persona } from '@/utils/persona'

export default {
  name: 'add-query',

  components: {
    Navbar,
    ModalQueryConfirmation,
    FeedbackRequest
  },

  data() {
    return {
      selected: null,
      options: persona,
      value: null,
      context: null,
      locale: 'pt-br',
      msg: null,
      labels: {
        ptBr: {
          labelNoDateSelected: 'Nenhuma data selecionada'
        }
      },
      queryParam: {
        dataConsulta: null,
        dataFormatada: null,
        idMedico: 0,
        observacao: null,
        paciente: null
      }
    }
  },

  computed: {
    getPacient() {
      if(this.selected) {
        let pacient = this.options.filter((item) => {
          return item.value == this.selected
        })
        return pacient
      }
    }
  },

  methods: {
    onContext(ctx) {
      this.context = ctx
    },

    async submit() {
      const isValid = await this.$refs.observer.validate()
      if (isValid) {
        this.queryParam = {
          dataConsulta: this.context.selectedDate,
          dataFormatada: this.context.selectedFormatted,
          idMedico: 0,
          observacao: this.msg,
          paciente: this.getPacient[0].text
        }
      }
    }
  }
}
</script>

<style lang="scss">
@mixin reselect-card {
  border: 1px solid rgba(0, 0, 0, 0.1);
  margin: 30px 0;
  padding: 30px;
  border-radius: 5px;
}

.addQuery-wrapper {
  min-height: 50vh;
  margin: 60px 0;
  border: 1px solid rgba(0, 0, 0, 0.1);
  padding: 50px;

  .addQuery-sidebar {
    .addQuery-sidebar--pacient {
      @include reselect-card;
      min-height: 350px;

      .img-content {      
        img {
          width: 90px;
          border-radius: 50%;
          height: 90px;
        }
      }

      h3 {
        margin-top: 30px;
      }
    }
  }

  .addQuery-form {
    .addQuery-form--sendbox {
      min-height: 320px;
      @include reselect-card;

      textarea {
        min-height: 345px;
      }
    }
  }

  button {
    height: 50px;
  }
}

#modal-1 {
  .btn {
    min-width: 150px;
    height: 50px;
  }
}

@media(max-width:1024px) {
  .addQuery-wrapper {
    padding: 0;
    border: 0;

    .addQuery-form {
      margin: 30px 0;

      label {
        margin-top: 30px;
      }
    }

    button {
      width: 100%;
    }
  }
}
</style>